# coding: utf-8
"""
    Cortex Inference API.

    OpenAPI 3.0 specification for the Cortex REST API  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from pydantic import BaseModel, ConfigDict, Field, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class StreamingCompleteResponseDataEventToolUseInner(BaseModel):
    """A model object representing the StreamingCompleteResponseDataEventToolUseInner resource.

    Constructs an object of type StreamingCompleteResponseDataEventToolUseInner with the provided properties.

    Parameters
    __________
    tool_use_id : str, optional

    name : str, optional

    input : object, optional
    """

    tool_use_id: Optional[StrictStr] = Field(default=None, alias="toolUseId")

    name: Optional[StrictStr] = None

    input: Optional[Dict[str, Any]] = None

    __properties = ["toolUseId", "name", "input"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias."""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias."""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(
            cls,
            json_str: str) -> StreamingCompleteResponseDataEventToolUseInner:
        """Create an instance of StreamingCompleteResponseDataEventToolUseInner from a JSON string."""
        return cls.from_dict(json.loads(json_str))

    def to_dict(
        self,
        hide_readonly_properties: bool = False,
    ) -> dict[str, Any]:
        """Returns the dictionary representation of the model using alias."""

        exclude_properties = set()

        if hide_readonly_properties:
            exclude_properties.update({})

        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude=exclude_properties,
                       exclude_none=True))

        return _dict

    def to_dict_without_readonly_properties(self) -> dict[str, Any]:
        """Return the dictionary representation of the model without readonly properties."""
        return self.to_dict(hide_readonly_properties=True)

    @classmethod
    def from_dict(cls,
                  obj: dict) -> StreamingCompleteResponseDataEventToolUseInner:
        """Create an instance of StreamingCompleteResponseDataEventToolUseInner from a dict."""

        if obj is None:
            return None

        if type(obj) is not dict:
            return StreamingCompleteResponseDataEventToolUseInner.parse_obj(
                obj)

        _obj = StreamingCompleteResponseDataEventToolUseInner.parse_obj({
            "tool_use_id":
            obj.get("toolUseId"),
            "name":
            obj.get("name"),
            "input":
            obj.get("input"),
        })

        return _obj


from typing import Optional, List, Dict


class StreamingCompleteResponseDataEventToolUseInnerModel():

    def __init__(
        self,  # optional properties
        tool_use_id: Optional[str] = None,
        name: Optional[str] = None,
        input: Optional[object] = None,
    ):
        """A model object representing the StreamingCompleteResponseDataEventToolUseInner resource.

        Constructs an object of type StreamingCompleteResponseDataEventToolUseInner with the provided properties.

        Parameters
        __________
        tool_use_id : str, optional

        name : str, optional

        input : object, optional
        """

        self.tool_use_id = tool_use_id
        self.name = name
        self.input = input

    __properties = ["toolUseId", "name", "input"]

    def _to_model(self):
        return StreamingCompleteResponseDataEventToolUseInner(
            tool_use_id=self.tool_use_id,
            name=self.name,
            input=self.input,
        )

    @classmethod
    def _from_model(
            cls, model) -> StreamingCompleteResponseDataEventToolUseInnerModel:
        return StreamingCompleteResponseDataEventToolUseInnerModel(
            tool_use_id=model.tool_use_id,
            name=model.name,
            input=model.input,
        )

    def to_dict(self):
        """Creates a dictionary of the properties from a StreamingCompleteResponseDataEventToolUseInner.

        This method constructs a dictionary with the key-value entries corresponding to the properties of the StreamingCompleteResponseDataEventToolUseInner object.

        Returns
        _______
        dict
            A dictionary object created using the input model.
        """
        return self._to_model().to_dict()

    @classmethod
    def from_dict(
            cls,
            obj: dict) -> StreamingCompleteResponseDataEventToolUseInnerModel:
        """Creates an instance of StreamingCompleteResponseDataEventToolUseInner from a dict.

        This method constructs a StreamingCompleteResponseDataEventToolUseInner object from a dictionary with the key-value pairs of its properties.

        Parameters
        ----------
        obj : dict
            A dictionary whose keys and values correspond to the properties of the resource object.

        Returns
        _______
        StreamingCompleteResponseDataEventToolUseInner
            A StreamingCompleteResponseDataEventToolUseInner object created using the input dictionary; this will fail if the required properties are missing.
        """
        return cls._from_model(
            StreamingCompleteResponseDataEventToolUseInner.from_dict(obj))


StreamingCompleteResponseDataEventToolUseInner._model_class = StreamingCompleteResponseDataEventToolUseInnerModel
